const { bestPractice } = require('eslint-config-coder-dev/src/rule/best_practice');
const { error } = require('eslint-config-coder-dev/src/rule/error');
const { style } = require('eslint-config-coder-dev/src/rule/style');

const typescriptStyle =
{
  '@typescript-eslint/adjacent-overload-signatures': 'error',
  'block-spacing': 'off',
  '@typescript-eslint/block-spacing': style['block-spacing'],
  'brace-style': 'off',
  '@typescript-eslint/brace-style': style['brace-style'],
  'comma-dangle': 'off',
  '@typescript-eslint/comma-dangle': style['comma-dangle'],
  'comma-spacing': 'off',
  '@typescript-eslint/comma-spacing': style['comma-spacing'],
  'default-param-last': 'off',
  '@typescript-eslint/default-param-last': bestPractice['default-param-last'],
  'dot-notation': 'off',
  '@typescript-eslint/dot-notation': style['dot-notation'],
  'func-call-spacing': 'off',
  '@typescript-eslint/func-call-spacing': style['func-call-spacing'],
  indent: 'off',
  '@typescript-eslint/indent': style.indent,
  'init-declarations': 'off',
  '@typescript-eslint/init-declarations': bestPractice['init-declarations'],
  'key-spacing': 'off',
  '@typescript-eslint/key-spacing': style['key-spacing'],
  'lines-between-class-members': 'off',
  '@typescript-eslint/lines-between-class-members': style['lines-between-class-members'],
  'no-array-constructor': 'off',
  '@typescript-eslint/no-array-constructor': error['no-array-constructor'],
  'no-dupe-class-members': 'off',
  '@typescript-eslint/no-dupe-class-members': error['no-dupe-class-members'],
  'no-empty-function': 'off',
  '@typescript-eslint/no-empty-function': error['no-empty-function'],
  'no-extra-parens': 'off',
  '@typescript-eslint/no-extra-parens': style['no-extra-parens'],
  'no-extra-semi': 'off',
  '@typescript-eslint/no-extra-semi': error['no-extra-semi'],
  'no-implied-eval': 'off',
  '@typescript-eslint/no-implied-eval': error['no-implied-eval'],
  'no-invalid-this': 'off',
  '@typescript-eslint/no-invalid-this': error['no-invalid-this'],
  'no-loop-func': 'off',
  '@typescript-eslint/no-loop-func': error['no-loop-func'],
  'no-loss-of-precision': 'off',
  '@typescript-eslint/no-loss-of-precision': error['no-loss-of-precision'],
  'no-magic-numbers': 'off',
  '@typescript-eslint/no-magic-numbers': error['no-magic-numbers'],
  'no-redeclare': 'off',
  '@typescript-eslint/no-redeclare': error['no-redeclare'],
  'no-restricted-imports': 'off',
  '@typescript-eslint/no-restricted-imports': error['no-restricted-imports'],
  'no-shadow': 'off',
  '@typescript-eslint/no-shadow': error['no-shadow'],
  'no-throw-literal': 'off',
  '@typescript-eslint/no-throw-literal': error['no-throw-literal'],
  'no-unused-expressions': 'off',
  '@typescript-eslint/no-unused-expressions': error['no-unused-expressions'],
  'no-unused-vars': 'off',
  '@typescript-eslint/no-unused-vars': error['no-unused-vars'],
  'no-use-before-define': 'off',
  '@typescript-eslint/no-use-before-define': error['no-use-before-define'],
  'no-useless-constructor': 'off',
  '@typescript-eslint/no-useless-constructor': error['no-useless-constructor'],
  'object-curly-spacing': 'off',
  '@typescript-eslint/object-curly-spacing': style['object-curly-spacing'],
  'padding-line-between-statements': 'off',
  '@typescript-eslint/padding-line-between-statements': style['padding-line-between-statements'],
  quotes: 'off',
  '@typescript-eslint/quotes': style.quotes,
  'require-await': 'off',
  '@typescript-eslint/require-await': bestPractice['require-await'],
  'no-return-await': 'off',
  '@typescript-eslint/return-await': error['no-return-await'],
  semi: 'off',
  '@typescript-eslint/semi': style.semi,
  'space-before-blocks': 'off',
  '@typescript-eslint/space-before-blocks': style['space-before-blocks'],
  'space-before-function-paren': 'off',
  '@typescript-eslint/space-before-function-paren': style['space-before-function-paren'],
  'space-infix-ops': 'off',
  '@typescript-eslint/space-infix-ops': style['space-infix-ops']
};

module.exports = { typescriptStyle };